<template>
  <!-- <div> -->
  <!-- <div>1111111111111111111111111111111111111111</div> -->
  <div :class="className" :style="{height:height,width:width}" />
  <!-- </div> -->
</template>

<script>
// import echarts from 'echarts'
import * as echarts from 'echarts'
require('echarts/theme/macarons') // echarts theme
import resize from './mixins/resize'

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    width: {
      type: String,
      default: '100%'
    },
    height: {
      type: String,
      default: '350px'
    },
    autoResize: {
      type: Boolean,
      default: true
    },
    chartData: {
      type: Object,
      required: true
    },
    interval: {
      type: Number,
      default: 1
    }
    // xdata: {
    //   type: Array,
    //   required: true
    // }
  },
  data() {
    return {
      chart: null
    }
  },
  watch: {
    chartData: {
      deep: true,
      handler(val) {
        this.setOptions(val)
      }
    }
    // xdata: {
    //   deep: true,
    //   handler(val) {
    //     console.log(val)
    //     this.setOptions(val)
    //     console.log('执行成功')
    //   }
    // }
  },
  mounted() {
    this.$nextTick(() => {
      this.initChart()
    })
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    initChart() {
      this.chart = echarts.init(this.$el, 'macarons')
      this.setOptions(this.chartData)
    },
    setOptions(val) {
      // console.log('组件设置的数据')
      // console.log(val)
      this.chart.setOption({
        title: {
          text: val.text,
          textStyle: {
            color: '#000000'
          }
        },
        xAxis: {
          data: val.xAxis,
          boundaryGap: false,
          axisTick: {
            show: false
          }
          // axisTick: { // 决定是否显示坐标刻度
          //   alignWithLabel: true,
          //   show: true
          // },
          // axisLine: {
          //   lineStyle: {
          //     color: '#000000'
          //   }
          // },
          // axisLabel: {
          //   interval: this.interval
          // }
        },
        grid: {
          left: '5%',
          right: '5%',
          bottom: '20%',
          top: '10%',
          containLabel: true,
          x: 120
        },
        toolbox: {
          feature: {
            dataZoom: {
              yAxisIndex: 'none'
            },
            restore: {},
            saveAsImage: {}
          }
        },
        tooltip: {
          trigger: 'axis',
          position: function(pt) {
            return [pt[0], '10%']
          }
        },
        // tooltip: {
        //   trigger: 'axis',
        //   axisPointer: {
        //     type: 'cross'
        //   },
        //   padding: [5, 10]
        // },
        yAxis: {
          axisTick: {
            show: false // 轴线刻度
          }
          // axisLine: {
          //   lineStyle: {
          //     color: '#000000'
          //   }
          // }
        },
        legend: {
          data: val.title,
          tooltip: {
            show: true
          }
        },
        dataZoom: [{
          type: 'inside',
          start: 0,
          end: 100
        }, {
          start: 0,
          end: 10
        }],
        series: val.series
        // [{
        //   name: JSON.parse(JSON.stringify(val.title)),
        //   itemStyle: {
        //     normal: {
        //       color: '#7AC5CD',
        //       lineStyle: {
        //         color: '#7AC5CD',
        //         width: 2
        //       }
        //     }
        //   },
        //   smooth: true,
        //   type: 'line',
        //   data: val.series,
        //   animationDuration: 2800,
        //   animationEasing: 'cubicInOut',
        //   areaStyle: {},
        //   label: {
        //     normal: {
        //       show: true,
        //       position: 'top'
        //     }
        //   }
        // }]
      }, true)
    }
  }
}
</script>
